package cofh.thermal.expansion.compat.jei;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cofh.thermal.core.ThermalCore;
import cofh.thermal.core.init.TCoreRecipeTypes;
import cofh.thermal.core.util.managers.dynamo.DisenchantmentFuelManager;
import cofh.thermal.core.util.managers.dynamo.GourmandFuelManager;
import cofh.thermal.core.util.managers.dynamo.StirlingFuelManager;
import cofh.thermal.core.util.managers.machine.BottlerRecipeManager;
import cofh.thermal.core.util.managers.machine.BrewerRecipeManager;
import cofh.thermal.core.util.managers.machine.FurnaceRecipeManager;
import cofh.thermal.core.util.recipes.dynamo.CompressionFuel;
import cofh.thermal.core.util.recipes.dynamo.DisenchantmentFuel;
import cofh.thermal.core.util.recipes.dynamo.GourmandFuel;
import cofh.thermal.core.util.recipes.dynamo.LapidaryFuel;
import cofh.thermal.core.util.recipes.dynamo.MagmaticFuel;
import cofh.thermal.core.util.recipes.dynamo.NumismaticFuel;
import cofh.thermal.core.util.recipes.dynamo.StirlingFuel;
import cofh.thermal.core.util.recipes.machine.BottlerRecipe;
import cofh.thermal.core.util.recipes.machine.BrewerRecipe;
import cofh.thermal.core.util.recipes.machine.CentrifugeRecipe;
import cofh.thermal.core.util.recipes.machine.ChillerRecipe;
import cofh.thermal.core.util.recipes.machine.CrucibleRecipe;
import cofh.thermal.core.util.recipes.machine.CrystallizerRecipe;
import cofh.thermal.core.util.recipes.machine.FurnaceRecipe;
import cofh.thermal.core.util.recipes.machine.InsolatorCatalyst;
import cofh.thermal.core.util.recipes.machine.InsolatorRecipe;
import cofh.thermal.core.util.recipes.machine.PressRecipe;
import cofh.thermal.core.util.recipes.machine.PulverizerCatalyst;
import cofh.thermal.core.util.recipes.machine.PulverizerRecipe;
import cofh.thermal.core.util.recipes.machine.PyrolyzerRecipe;
import cofh.thermal.core.util.recipes.machine.RefineryRecipe;
import cofh.thermal.core.util.recipes.machine.SawmillRecipe;
import cofh.thermal.core.util.recipes.machine.SmelterCatalyst;
import cofh.thermal.core.util.recipes.machine.SmelterRecipe;
import cofh.thermal.expansion.client.gui.dynamo.DynamoCompressionScreen;
import cofh.thermal.expansion.client.gui.dynamo.DynamoDisenchantmentScreen;
import cofh.thermal.expansion.client.gui.dynamo.DynamoGourmandScreen;
import cofh.thermal.expansion.client.gui.dynamo.DynamoLapidaryScreen;
import cofh.thermal.expansion.client.gui.dynamo.DynamoMagmaticScreen;
import cofh.thermal.expansion.client.gui.dynamo.DynamoNumismaticScreen;
import cofh.thermal.expansion.client.gui.dynamo.DynamoStirlingScreen;
import cofh.thermal.expansion.client.gui.machine.MachineBottlerScreen;
import cofh.thermal.expansion.client.gui.machine.MachineBrewerScreen;
import cofh.thermal.expansion.client.gui.machine.MachineCentrifugeScreen;
import cofh.thermal.expansion.client.gui.machine.MachineChillerScreen;
import cofh.thermal.expansion.client.gui.machine.MachineCrucibleScreen;
import cofh.thermal.expansion.client.gui.machine.MachineCrystallizerScreen;
import cofh.thermal.expansion.client.gui.machine.MachineFurnaceScreen;
import cofh.thermal.expansion.client.gui.machine.MachineInsolatorScreen;
import cofh.thermal.expansion.client.gui.machine.MachinePressScreen;
import cofh.thermal.expansion.client.gui.machine.MachinePulverizerScreen;
import cofh.thermal.expansion.client.gui.machine.MachinePyrolyzerScreen;
import cofh.thermal.expansion.client.gui.machine.MachineRefineryScreen;
import cofh.thermal.expansion.client.gui.machine.MachineSawmillScreen;
import cofh.thermal.expansion.client.gui.machine.MachineSmelterScreen;
import cofh.thermal.expansion.compat.jei.dynamo.CompressionFuelCategory;
import cofh.thermal.expansion.compat.jei.dynamo.DisenchantmentFuelCategory;
import cofh.thermal.expansion.compat.jei.dynamo.GourmandFuelCategory;
import cofh.thermal.expansion.compat.jei.dynamo.LapidaryFuelCategory;
import cofh.thermal.expansion.compat.jei.dynamo.MagmaticFuelCategory;
import cofh.thermal.expansion.compat.jei.dynamo.NumismaticFuelCategory;
import cofh.thermal.expansion.compat.jei.dynamo.StirlingFuelCategory;
import cofh.thermal.expansion.compat.jei.machine.BottlerRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.BrewerRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.CentrifugeRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.ChillerRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.CrucibleRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.CrystallizerRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.FurnaceRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.InsolatorCatalystCategory;
import cofh.thermal.expansion.compat.jei.machine.InsolatorRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.PotionFluidRecipeManagerPlugin;
import cofh.thermal.expansion.compat.jei.machine.PressRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.PulverizerCatalystCategory;
import cofh.thermal.expansion.compat.jei.machine.PulverizerRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.PyrolyzerRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.RefineryRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.SawmillRecipeCategory;
import cofh.thermal.expansion.compat.jei.machine.SmelterCatalystCategory;
import cofh.thermal.expansion.compat.jei.machine.SmelterRecipeCategory;
import java.util.ArrayList;
import mezz.jei.api.IModPlugin;
import mezz.jei.api.JeiPlugin;
import mezz.jei.api.constants.RecipeTypes;
import mezz.jei.api.recipe.RecipeType;
import mezz.jei.api.recipe.advanced.IRecipeManagerPlugin;
import mezz.jei.api.recipe.category.IRecipeCategory;
import mezz.jei.api.registration.IAdvancedRegistration;
import mezz.jei.api.registration.IGuiHandlerRegistration;
import mezz.jei.api.registration.IRecipeCatalystRegistration;
import mezz.jei.api.registration.IRecipeCategoryRegistration;
import mezz.jei.api.registration.IRecipeRegistration;
import net.minecraft.client.Minecraft;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.RecipeManager;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.level.ItemLike;

@JeiPlugin
public class TExpJeiPlugin implements IModPlugin {
  public void registerRecipes(IRecipeRegistration registration) {
    RecipeManager recipeManager = getRecipeManager();
    if (recipeManager == null)
      return; 
    registration.addRecipes(FURNACE, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_FURNACE));
    registration.addRecipes(FURNACE, FurnaceRecipeManager.instance().getConvertedRecipes());
    registration.addRecipes(SAWMILL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_SAWMILL));
    registration.addRecipes(PULVERIZER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_PULVERIZER));
    registration.addRecipes(PULVERIZER, new ArrayList(recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_PULVERIZER_RECYCLE)));
    registration.addRecipes(PULVERIZER_CATALYST, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.CATALYST_PULVERIZER));
    registration.addRecipes(SMELTER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_SMELTER));
    registration.addRecipes(SMELTER, new ArrayList(recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_SMELTER_RECYCLE)));
    registration.addRecipes(SMELTER_CATALYST, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.CATALYST_SMELTER));
    registration.addRecipes(INSOLATOR, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_INSOLATOR));
    registration.addRecipes(INSOLATOR_CATALYST, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.CATALYST_INSOLATOR));
    registration.addRecipes(CENTRIFUGE, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_CENTRIFUGE));
    registration.addRecipes(PRESS, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_PRESS));
    registration.addRecipes(CRUCIBLE, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_CRUCIBLE));
    registration.addRecipes(CHILLER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_CHILLER));
    registration.addRecipes(REFINERY, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_REFINERY));
    registration.addRecipes(PYROLYZER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_PYROLYZER));
    registration.addRecipes(BREWER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_BREWER));
    registration.addRecipes(BREWER, BrewerRecipeManager.instance().getConvertedRecipes());
    registration.addRecipes(BOTTLER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_BOTTLER));
    registration.addRecipes(BOTTLER, BottlerRecipeManager.instance().getConvertedRecipes());
    registration.addRecipes(CRYSTALLIZER, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.RECIPE_CRYSTALLIZER));
    registration.addRecipes(STIRLING_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_STIRLING));
    registration.addRecipes(STIRLING_FUEL, StirlingFuelManager.instance().getConvertedFuels());
    registration.addRecipes(COMPRESSION_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_COMPRESSION));
    registration.addRecipes(MAGMATIC_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_MAGMATIC));
    registration.addRecipes(NUMISMATIC_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_NUMISMATIC));
    registration.addRecipes(LAPIDARY_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_LAPIDARY));
    registration.addRecipes(DISENCHANTMENT_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_DISENCHANTMENT));
    registration.addRecipes(DISENCHANTMENT_FUEL, DisenchantmentFuelManager.instance().getConvertedFuels());
    registration.addRecipes(GOURMAND_FUEL, recipeManager.m_44013_((RecipeType)TCoreRecipeTypes.FUEL_GOURMAND));
    registration.addRecipes(GOURMAND_FUEL, GourmandFuelManager.instance().getConvertedFuels());
  }
  
  public void registerCategories(IRecipeCategoryRegistration registration) {
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new FurnaceRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_furnace")), TCoreRecipeTypes.ID_RECIPE_FURNACE) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new SawmillRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_sawmill")), TCoreRecipeTypes.ID_RECIPE_SAWMILL) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new PulverizerRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_pulverizer")), TCoreRecipeTypes.ID_RECIPE_PULVERIZER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new SmelterRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_smelter")), TCoreRecipeTypes.ID_RECIPE_SMELTER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new InsolatorRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_insolator")), TCoreRecipeTypes.ID_RECIPE_INSOLATOR) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new CentrifugeRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_centrifuge")), TCoreRecipeTypes.ID_RECIPE_CENTRIFUGE) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new PressRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_press")), TCoreRecipeTypes.ID_RECIPE_PRESS) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new CrucibleRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_crucible")), TCoreRecipeTypes.ID_RECIPE_CRUCIBLE) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new ChillerRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_chiller")), TCoreRecipeTypes.ID_RECIPE_CHILLER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new RefineryRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_refinery")), TCoreRecipeTypes.ID_RECIPE_REFINERY) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new PyrolyzerRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_pyrolyzer")), TCoreRecipeTypes.ID_RECIPE_PYROLYZER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new BrewerRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_brewer")), TCoreRecipeTypes.ID_RECIPE_BREWER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new BottlerRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_bottler")), TCoreRecipeTypes.ID_RECIPE_BOTTLER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new CrystallizerRecipeCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_crystallizer")), TCoreRecipeTypes.ID_RECIPE_CRYSTALLIZER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new PulverizerCatalystCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.ITEMS.get("basalz_powder")), TCoreRecipeTypes.ID_CATALYST_PULVERIZER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new SmelterCatalystCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.ITEMS.get("cinnabar")), TCoreRecipeTypes.ID_CATALYST_SMELTER) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new InsolatorCatalystCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.ITEMS.get("phytogro")), TCoreRecipeTypes.ID_CATALYST_INSOLATOR) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new StirlingFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_stirling")), TCoreRecipeTypes.ID_FUEL_STIRLING) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new CompressionFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_compression")), TCoreRecipeTypes.ID_FUEL_COMPRESSION) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new MagmaticFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_magmatic")), TCoreRecipeTypes.ID_FUEL_MAGMATIC) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new NumismaticFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_numismatic")), TCoreRecipeTypes.ID_FUEL_NUMISMATIC) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new LapidaryFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_lapidary")), TCoreRecipeTypes.ID_FUEL_LAPIDARY) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new DisenchantmentFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_disenchantment")), TCoreRecipeTypes.ID_FUEL_DISENCHANTMENT) });
    registration.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new GourmandFuelCategory(registration.getJeiHelpers().getGuiHelper(), new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_gourmand")), TCoreRecipeTypes.ID_FUEL_GOURMAND) });
  }
  
  public void registerGuiHandlers(IGuiHandlerRegistration registration) {
    int progressY = 35;
    int progressW = 24;
    int progressH = 16;
    registration.addRecipeClickArea(MachineFurnaceScreen.class, 79, progressY, progressW, progressH, new RecipeType[] { FURNACE });
    registration.addRecipeClickArea(MachineSawmillScreen.class, 72, progressY, progressW, progressH, new RecipeType[] { SAWMILL });
    registration.addRecipeClickArea(MachinePulverizerScreen.class, 72, progressY, progressW, progressH, new RecipeType[] { PULVERIZER });
    registration.addRecipeClickArea(MachineSmelterScreen.class, 94, progressY, progressW, progressH, new RecipeType[] { SMELTER });
    registration.addRecipeClickArea(MachineInsolatorScreen.class, 85, progressY, progressW, progressH, new RecipeType[] { INSOLATOR });
    registration.addRecipeClickArea(MachineCentrifugeScreen.class, 72, progressY, progressW, progressH, new RecipeType[] { CENTRIFUGE });
    registration.addRecipeClickArea(MachinePressScreen.class, 79, progressY, progressW, progressH, new RecipeType[] { PRESS });
    registration.addRecipeClickArea(MachineCrucibleScreen.class, 84, progressY, progressW, progressH, new RecipeType[] { CRUCIBLE });
    registration.addRecipeClickArea(MachineChillerScreen.class, 88, progressY, progressW, progressH, new RecipeType[] { CHILLER });
    registration.addRecipeClickArea(MachineRefineryScreen.class, 65, progressY, progressW, progressH, new RecipeType[] { REFINERY });
    registration.addRecipeClickArea(MachinePyrolyzerScreen.class, 72, progressY, progressW, progressH, new RecipeType[] { PYROLYZER });
    registration.addRecipeClickArea(MachineBottlerScreen.class, 88, progressY, progressW, progressH, new RecipeType[] { BOTTLER });
    registration.addRecipeClickArea(MachineBrewerScreen.class, 88, progressY, progressW, progressH, new RecipeType[] { BREWER });
    registration.addRecipeClickArea(MachineCrystallizerScreen.class, 105, progressY, progressW, progressH, new RecipeType[] { CRYSTALLIZER });
    registration.addRecipeClickArea(MachineCrystallizerScreen.class, 110, 22, progressW, progressH, new RecipeType[] { RecipeTypes.CRAFTING });
    registration.addRecipeClickArea(MachinePulverizerScreen.class, 72, progressY, progressW, progressH, new RecipeType[] { PULVERIZER_CATALYST });
    registration.addRecipeClickArea(MachineSmelterScreen.class, 94, progressY, progressW, progressH, new RecipeType[] { SMELTER_CATALYST });
    registration.addRecipeClickArea(MachineInsolatorScreen.class, 85, progressY, progressW, progressH, new RecipeType[] { INSOLATOR_CATALYST });
    registration.addRecipeClickArea(DynamoStirlingScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { STIRLING_FUEL });
    registration.addRecipeClickArea(DynamoCompressionScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { COMPRESSION_FUEL });
    registration.addRecipeClickArea(DynamoMagmaticScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { MAGMATIC_FUEL });
    registration.addRecipeClickArea(DynamoNumismaticScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { NUMISMATIC_FUEL });
    registration.addRecipeClickArea(DynamoLapidaryScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { LAPIDARY_FUEL });
    registration.addRecipeClickArea(DynamoDisenchantmentScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { DISENCHANTMENT_FUEL });
    registration.addRecipeClickArea(DynamoGourmandScreen.class, 80, progressY, progressH, progressH, new RecipeType[] { GOURMAND_FUEL });
  }
  
  public void registerRecipeCatalysts(IRecipeCatalystRegistration registration) {
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_furnace")), new RecipeType[] { FURNACE });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_sawmill")), new RecipeType[] { SAWMILL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_pulverizer")), new RecipeType[] { PULVERIZER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_pulverizer")), new RecipeType[] { PULVERIZER_CATALYST });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_smelter")), new RecipeType[] { SMELTER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_smelter")), new RecipeType[] { SMELTER_CATALYST });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_insolator")), new RecipeType[] { INSOLATOR });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_insolator")), new RecipeType[] { INSOLATOR_CATALYST });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_centrifuge")), new RecipeType[] { CENTRIFUGE });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_press")), new RecipeType[] { PRESS });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_crucible")), new RecipeType[] { CRUCIBLE });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_chiller")), new RecipeType[] { CHILLER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_refinery")), new RecipeType[] { REFINERY });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_pyrolyzer")), new RecipeType[] { PYROLYZER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_bottler")), new RecipeType[] { BOTTLER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_brewer")), new RecipeType[] { BREWER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_crystallizer")), new RecipeType[] { CRYSTALLIZER });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("machine_crafter")), new RecipeType[] { RecipeTypes.CRAFTING });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_stirling")), new RecipeType[] { STIRLING_FUEL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_compression")), new RecipeType[] { COMPRESSION_FUEL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_magmatic")), new RecipeType[] { MAGMATIC_FUEL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_numismatic")), new RecipeType[] { NUMISMATIC_FUEL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_lapidary")), new RecipeType[] { LAPIDARY_FUEL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_disenchantment")), new RecipeType[] { DISENCHANTMENT_FUEL });
    registration.addRecipeCatalyst(new ItemStack((ItemLike)ThermalCore.BLOCKS.get("dynamo_gourmand")), new RecipeType[] { GOURMAND_FUEL });
  }
  
  public void registerAdvanced(IAdvancedRegistration registration) {
    registration.addRecipeManagerPlugin((IRecipeManagerPlugin)new PotionFluidRecipeManagerPlugin());
  }
  
  public ResourceLocation getPluginUid() {
    return new ResourceLocation("thermal", "expansion");
  }
  
  private RecipeManager getRecipeManager() {
    RecipeManager recipeManager = null;
    ClientLevel level = (Minecraft.m_91087_()).f_91073_;
    if (level != null)
      recipeManager = level.m_7465_(); 
    return recipeManager;
  }
  
  public static final RecipeType<FurnaceRecipe> FURNACE = new RecipeType(TCoreRecipeTypes.ID_RECIPE_FURNACE, FurnaceRecipe.class);
  
  public static final RecipeType<SawmillRecipe> SAWMILL = new RecipeType(TCoreRecipeTypes.ID_RECIPE_SAWMILL, SawmillRecipe.class);
  
  public static final RecipeType<PulverizerRecipe> PULVERIZER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_PULVERIZER, PulverizerRecipe.class);
  
  public static final RecipeType<SmelterRecipe> SMELTER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_SMELTER, SmelterRecipe.class);
  
  public static final RecipeType<InsolatorRecipe> INSOLATOR = new RecipeType(TCoreRecipeTypes.ID_RECIPE_INSOLATOR, InsolatorRecipe.class);
  
  public static final RecipeType<CentrifugeRecipe> CENTRIFUGE = new RecipeType(TCoreRecipeTypes.ID_RECIPE_CENTRIFUGE, CentrifugeRecipe.class);
  
  public static final RecipeType<PressRecipe> PRESS = new RecipeType(TCoreRecipeTypes.ID_RECIPE_PRESS, PressRecipe.class);
  
  public static final RecipeType<CrucibleRecipe> CRUCIBLE = new RecipeType(TCoreRecipeTypes.ID_RECIPE_CRUCIBLE, CrucibleRecipe.class);
  
  public static final RecipeType<ChillerRecipe> CHILLER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_CHILLER, ChillerRecipe.class);
  
  public static final RecipeType<RefineryRecipe> REFINERY = new RecipeType(TCoreRecipeTypes.ID_RECIPE_REFINERY, RefineryRecipe.class);
  
  public static final RecipeType<PyrolyzerRecipe> PYROLYZER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_PYROLYZER, PyrolyzerRecipe.class);
  
  public static final RecipeType<BottlerRecipe> BOTTLER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_BOTTLER, BottlerRecipe.class);
  
  public static final RecipeType<CrystallizerRecipe> CRYSTALLIZER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_CRYSTALLIZER, CrystallizerRecipe.class);
  
  public static final RecipeType<BrewerRecipe> BREWER = new RecipeType(TCoreRecipeTypes.ID_RECIPE_BREWER, BrewerRecipe.class);
  
  public static final RecipeType<PulverizerCatalyst> PULVERIZER_CATALYST = new RecipeType(TCoreRecipeTypes.ID_CATALYST_PULVERIZER, PulverizerCatalyst.class);
  
  public static final RecipeType<SmelterCatalyst> SMELTER_CATALYST = new RecipeType(TCoreRecipeTypes.ID_CATALYST_SMELTER, SmelterCatalyst.class);
  
  public static final RecipeType<InsolatorCatalyst> INSOLATOR_CATALYST = new RecipeType(TCoreRecipeTypes.ID_CATALYST_INSOLATOR, InsolatorCatalyst.class);
  
  public static final RecipeType<StirlingFuel> STIRLING_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_STIRLING, StirlingFuel.class);
  
  public static final RecipeType<CompressionFuel> COMPRESSION_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_COMPRESSION, CompressionFuel.class);
  
  public static final RecipeType<MagmaticFuel> MAGMATIC_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_MAGMATIC, MagmaticFuel.class);
  
  public static final RecipeType<NumismaticFuel> NUMISMATIC_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_NUMISMATIC, NumismaticFuel.class);
  
  public static final RecipeType<LapidaryFuel> LAPIDARY_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_LAPIDARY, LapidaryFuel.class);
  
  public static final RecipeType<DisenchantmentFuel> DISENCHANTMENT_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_DISENCHANTMENT, DisenchantmentFuel.class);
  
  public static final RecipeType<GourmandFuel> GOURMAND_FUEL = new RecipeType(TCoreRecipeTypes.ID_FUEL_GOURMAND, GourmandFuel.class);
}
